<?php
/*======================================================================*\
|| #################################################################### ||
|| # Youjoomla.com - YJ- Licence Number 98197-KQ261883
|| # Licensed to - Hejakal Bekaudar
|| # ---------------------------------------------------------------- # ||
|| # Copyright (C) Since 2006 Youjoomla.com. All Rights Reserved.       ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/

// no direct access
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.framework',true);
require_once (JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_content'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'route.php');
require_once('modules/mod_youroller_slider/lib/slike.php');

class modYourollerHelper
{
	function getYourolleritems(&$params)
	{
		global $mainframe;
		$get_items                	= $params->get   ('get_items',1);
		$getspecific 				= $params->get ('getspecific');
		$nitems                   	= $params->get   ('nitems',4);
		$chars                    	= $params->get   ('chars',40);
		$ordering                 	= $params->get   ('ordering',3);// 1 = ordering | 2 = popular | 3 = random 
		$specificitems 	        	= $params->get   ('specificitems','');
		$allow_tags					= $params->get ('allow_tags');
		
		$slider_width				= $params->get   ('slider_width','');
		$slider_height				= $params->get   ('slider_height','');
		
		$imgwidth         	    	= $params->get ('imgwidth');	
		$imgheight					= $params->get ('imgheight');
		$showimage					= $params->get ('showimage');
		$big_img_pos				= $params->get   ('big_img_pos');
		$med_img_pos				= $params->get   ('med_img_pos');
		$sma_img_pos				= $params->get   ('sma_img_pos');
		$xsm_img_pos				= $params->get   ('xsm_img_pos');
		$big_img_pos_l				= $params->get   ('big_img_pos_l');
		$med_img_pos_l				= $params->get   ('med_img_pos_l');
		$sma_img_pos_l				= $params->get   ('sma_img_pos_l');
		$xsm_img_pos_l				= $params->get   ('xsm_img_pos_l');
		$big_img_show		    	= $params->get   ('big_img_show');
		$med_img_show				= $params->get   ('med_img_show');
		$sma_img_show				= $params->get   ('sma_img_show');
		$xsm_img_show				= $params->get   ('xsm_img_show');
		
		$bounceDist					= $params->get   ('bounceDist','100');
		$bounceTime					= $params->get   ('bounceTime','500');
		$outside				    = $params->get   ('outside','2000');
		$autoslide					= $params->get   ('autoslide','5000');
		
		/* add styles and scripts */			
		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::base() . 'modules/mod_youroller_slider/css/stylesheet.css');
		$document->addScript(JURI::base() . 'modules/mod_youroller_slider/script/mod_youroller_slider12.js');
		$document->addScriptDeclaration("
		window.addEvent('domready', function(){
			new YouRoller({container: 'YouRollerSlider',
								slideClass: 'slide',
								nextBtnContainer: 'buttons',
								nextBtnClass: 'next', 
								nextBtnText: 'next slide',
								bounceDist: ".$bounceDist.",
								bounceTime: ".$bounceTime.",
								outside:".$outside.",
								autoslide: ".$autoslide."
			});
		})
		");
		/* prepare database */
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$userId		= (int) $user->get('id');
		$aid		= JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contentConfig = JComponentHelper::getParams( 'com_content' );
		$access		= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$nullDate	= $db->getNullDate();
		$date =        JFactory::getDate();
		if(intval(JVERSION) >= 3 ){	
			$now =         $date->toSql() ; 
		}else{
			$now =         $date->toMySQL(); 
		}
		
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		// select specific items
		if(!empty($getspecific)){
		$countitems = count($getspecific);
		}
		if(!empty($getspecific) && $countitems > 1 ){
			$specificitems = implode(",", $getspecific);
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}elseif(!empty($getspecific) && $countitems == 1 ){
			$specificitems = $getspecific[0];
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}else{
			$specificitems='';
			$specific_order='NULL';
			$where .= ' AND cc.id = '.$get_items.'';
		}
		/* set items order */
		$ord = array(
			1=>'ordering',
			2=>'hits',
			3=>'RAND()',
			4=>'created ASC',
			5=>'created DESC',
			6=>$specific_order
		);
		$order = $ord[$ordering];
		/* get items */
		$sql = 	'SELECT a.*, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'. 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
				'cc.title as cattitle'.
		
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE '. $where .'' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : '').
				' AND cc.published = 1' .
				' ORDER BY '.$order .' LIMIT 0,'.$nitems.'';
		$db->setQuery( $sql );
		$load_items = $db->loadObjectList();

		
			$yourollerslides = array();
			foreach ( $load_items as $row ) {
			$yourollerslide = array(
				'date' 		=> JHTML::_('date', $row->created,JText::_('CREATEDATE')),
				'intro' 	=> substr(strip_tags($row->introtext,''.$allow_tags.''),0,$chars),
				'link' 		=> htmlspecialchars(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug), ENT_QUOTES, 'UTF-8'),
				'img_url' 	=> $img_url = article_yourollerimg($row),
				'title' 	=> htmlspecialchars($row->title, ENT_QUOTES, 'UTF-8'),
				'img_url' 	=> '',
				'img_out' 	=> $img_url
			);
			$yourollerslides[] = $yourollerslide;
			}

			return $yourollerslides;
	}

}

?>